//http://seta43.duckdns.org/
//http://seta43.blogspot.com/
//xsetaseta@gmail.com
// SETA43
// Programa hecho por JUAN GALAZ
//25/03/2021


#include <avr/io.h>
#include <avr/interrupt.h>


#define DELAY_LCD  2

#define BUTTON1 A2
#define BUTTON2 A3

#define SEGA 2
#define SEGB 3
#define SEGC 4
#define SEGD 5
#define SEGE 6
#define SEGF 7
#define SEGG 8


#define DIGITO1 9
#define DIGITO2 10
#define DIGITO3 11
#define DIGITO4 12

#define DIGITO5 14



unsigned char numerosD[11]={32,111,20,6,75,130,128,103,0,2};
unsigned char digitos[6]={1,2,3,4,5,6};

int horas, minutos, segundos, dias;
byte bandera = 0;
char time[15];

bool parpadeo;
unsigned char Dparpadeo;

void printDigito(unsigned char num, unsigned char dig )
{
 unsigned char dato;
   if(num<10) dato=numerosD[num];

 
    switch(dig)
    {
      case 7:
        dato=num;
        digitalWrite(DIGITO5, LOW);
        digitalWrite(DIGITO4, HIGH);digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO2, HIGH);  digitalWrite(DIGITO1, HIGH);
      break;
      case 6:
        digitalWrite(DIGITO4, LOW);
        digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO2, HIGH);  digitalWrite(DIGITO1, HIGH);
      break;
      case 5:
        digitalWrite(DIGITO3, LOW);
        digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO4, HIGH); digitalWrite(DIGITO2, HIGH);  digitalWrite(DIGITO1, HIGH);
      break;
      case 4:
        digitalWrite(DIGITO2, LOW);
        digitalWrite(DIGITO5, HIGH);digitalWrite(DIGITO4, HIGH); digitalWrite(DIGITO3, HIGH);  digitalWrite(DIGITO1, HIGH);
      break;
      case 3:
        digitalWrite(DIGITO1, LOW);
        digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO2, HIGH);  digitalWrite(DIGITO4, HIGH);
      break;
    }
 
    if(dato&2)  digitalWrite(SEGA,HIGH ); else  digitalWrite(SEGA,LOW);
    if(dato&4)  digitalWrite(SEGB,HIGH ); else  digitalWrite(SEGB,LOW);
    if(dato&8)  digitalWrite(SEGC,HIGH ); else  digitalWrite(SEGC,LOW);
    if(dato&16)  digitalWrite(SEGD,HIGH ); else  digitalWrite(SEGD,LOW);
    if(dato&32)  digitalWrite(SEGE,HIGH ); else  digitalWrite(SEGE,LOW);
    if(dato&64)  digitalWrite(SEGF,HIGH ); else  digitalWrite(SEGF,LOW);
    if(dato&128)  digitalWrite(SEGG,HIGH ); else  digitalWrite(SEGG,LOW);
}


void printDigitos(int num)
{
    sprintf(digitos,"%04d",num);    
}

void displayDigitos(void)
{
  printDigito(digitos[2],3); delay(DELAY_LCD);
  printDigito(digitos[3],4); delay(DELAY_LCD);
  printDigito(digitos[4],5); delay(DELAY_LCD);
  printDigito(digitos[5],6); delay(DELAY_LCD);
  printDigito(Dparpadeo,7); delay(DELAY_LCD);
}


void setup() 
{
  Serial.begin(9600);
  // put your setup code here, to run once:
  pinMode(13, OUTPUT);
  pinMode(SEGA, OUTPUT);
  pinMode(SEGB, OUTPUT);
  pinMode(SEGC, OUTPUT);
  pinMode(SEGD, OUTPUT);
  pinMode(SEGE, OUTPUT);
  pinMode(SEGF, OUTPUT);
  pinMode(SEGG, OUTPUT);

  pinMode(15, OUTPUT);
  
  pinMode(DIGITO1, OUTPUT);
  pinMode(DIGITO2, OUTPUT);
  pinMode(DIGITO3, OUTPUT);
  pinMode(DIGITO4, OUTPUT);
  pinMode(DIGITO5, OUTPUT);

  //for(int z=2;z<15;z++)    digitalWrite(z, HIGH); 
  pinMode(BUTTON1, INPUT);
  pinMode(BUTTON2, INPUT);  

  cli();
  TCCR1A = 0;
  TCCR1B = 0;
  OCR1A = 15624;
  TCCR1B |= (1 << WGM12);
  TCCR1B |= (1 << CS10);
  TCCR1B |= (1 << CS12);
  TIMSK1 = (1 << OCIE1A);
  sei();
  
}

void loop() 
{
  if(LOW==digitalRead(BUTTON1))
    {
      minutos++;
      if(minutos>59) minutos=0;
      segundos=0;
      bandera=1;
      delay(50);
      while(LOW==digitalRead(BUTTON1)) delay(200);
    }
   if(LOW==digitalRead(BUTTON2))
    {
      horas++;
      if(horas>23) horas=0;
      bandera=1;
      delay(50);
      while(LOW==digitalRead(BUTTON2)) delay(200);
    }
  
  if (bandera == 1)
  {
    bandera = 0;
    printTime();
  }
  
    displayDigitos();

}



void printTime()
{
  sprintf(time, "%02d:%02d:%02d", horas, minutos, segundos);

  if(parpadeo==1) 
      Dparpadeo=127; 
     else
      Dparpadeo=0;
    
  //Dparpadeo=segundos; 

  digitos[5]=time[4]-48;
  digitos[4]=time[3]-48;
  digitos[3]=time[1]-48;
  digitos[2]=time[0]-48;
                                                                                                                                          
  Serial.println(time);
}


ISR(TIMER1_COMPA_vect)
{
  if(parpadeo==1)parpadeo=0; else parpadeo=1;
  bandera = 1;
  segundos++;
  if (segundos > 59)
  {
    segundos = 0;
    minutos++;
    if (minutos > 59)
    {
      minutos = 0;
      horas++;
      if (horas > 23)
      {
        segundos = 0;
        minutos = 0;
        horas = 0;
        dias++;
      }
    }
  }
}
